libreorganize/apps/votations/urls.py
from django.urls import path

from apps.votations import views

app_name = "apps.votations"

urlpatterns = [
    # Requires LIST permissions
    path("", views.ListView.as_view(), name="list"),
    # Requires NO permissions
    path("list/", views.PublicListView.as_view(), name="public_list"),
    path("<int:pk>/results/", views.ResultView.as_view(), name="results"),
    # Requires MANAGE permissions
    path("create/", views.CreateView.as_view(), name="create"),
    path("<int:pk>/", views.DetailView.as_view(), name="detail"),
    path("<int:pk>/edit/", views.EditView.as_view(), name="edit"),
    path("<int:pk>/delete/", views.DeleteView.as_view(), name="delete"),
    # Requires user to AUTHENTICATE
    path("<int:pk>/vote/", views.VoteView.as_view(), name="vote"),
    path("<int:pk>/voterank/", views.VoteRankedView.as_view(), name="voterank"),
]

libreorganize/core/urls.py
import os

from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.views.generic import TemplateView

urlpatterns = []

if os.path.exists(os.path.join(settings.BASE_DIR, "theme")):
    from theme.urls import *

urlpatterns += [
    path("", TemplateView.as_view(template_name="home.html"), name="home"),
    path("accounts/", include("apps.accounts.urls", namespace="accounts")),
    path("boxes/", include("apps.boxes.urls", namespace="boxes")),
    path("events/", include("apps.events.urls", namespace="events")),
    path("news/", include("apps.news.urls", namespace="news")),
    path("votations/", include("apps.votations.urls", namespace="votations")),
    path("wikis/", include("apps.wikis.urls", namespace="wikis")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ckeditor/", include("ckeditor_uploader.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

libreorganize/apps/votations/models.py
import datetime

from django.conf import settings
from django.db import models
from django.utils.translation import gettext_lazy as _

from apps.accounts.models import Account, Group


class Votation(models.Model):
    # This represents a vote to be taken
    topic = models.CharField(max_length=128)
    description = models.TextField()
    votation_type = models.CharField(max_length=16, default="normal", choices=settings.TYPE_VOTING)
    start_date = models.DateTimeField(help_text=_("Must be formatted as YYYY-MM-DD HH:MM"))
    end_date = models.DateTimeField(help_text=_("Must be formatted as YYYY-MM-DD HH:MM"))
    groups = models.ManyToManyField(Group, related_name="votations", blank=True)
    winner = models.OneToOneField("VotationChoice", null=True, blank=True, on_delete=models.CASCADE, related_name="+")
    voters = models.ManyToManyField(Account, related_name="votations")

    class Meta:
        default_permissions = ()
        permissions = (
            ("list_votations", "List votations"),
            ("manage_votations", "Manage votations"),
        )

    def get_votation_status(self):
        now = datetime.datetime.now()
        if now >= self.end_date:
            return "closed"
        elif self.start_date <= now < self.end_date:
            return "open"
        return "pending"

    def get_votation_status_display(self):
        now = datetime.datetime.now()
        if self.start_date <= now < self.end_date:
            return _("Open")
        if now >= self.end_date:
            return _("Closed")
        return _("Pending")


class VotationChoice(models.Model):
    # This represents an individual candidate or choice in a votation
    name = models.CharField(max_length=64)
    votation = models.ForeignKey(Votation, on_delete=models.CASCADE)

    class Meta:
        default_permissions = ()
        ordering = ("name",)


class VotationVote(models.Model):
    class Meta:
        default_permissions = ()


class VotationDecision(models.Model):
    # This represents a cast vote or elected choice made by an individual for VotationChoice (e.g., candidate) in a Votation
    vote = models.ForeignKey(VotationVote, on_delete=models.CASCADE, default="", null=True, blank=True)
    votation = models.ForeignKey(Votation, on_delete=models.CASCADE)
    choice = models.ForeignKey(VotationChoice, on_delete=models.CASCADE)
    time_cast = models.DateTimeField(auto_now_add=True)
    rank = models.IntegerField(null=True, blank=True)

    class Meta:
        default_permissions = ()

libreorganize/apps/votations/views.py
from datetime import datetime
from random import randint

from django.contrib import messages
from django.db import transaction
from django.db.models import Count
from django.forms import inlineformset_factory
from django.http import HttpResponseRedirect
from django.urls import reverse_lazy
from django.utils.translation import gettext_lazy as _
from django.views.generic import FormView
from django.shortcuts import render
from django.core.paginator import Paginator

from apps.votations.forms import (
    VotationChoiceModelForm,
    VotationChoicesFormSet,
    VotationDecisionForm,
    VotationForm,
    VotationRankedDecisionForm,
)
from apps.votations.models import Votation, VotationChoice, VotationDecision, VotationVote
from apps.votations.utils import Election
from core.mixins import PermissionMixin, GroupPermissionMixin
from core.views import CoreCreateView, CoreDeleteView, CoreDetailView, CoreEditView, CoreListView


class ListView(CoreListView):
    personal = False
    permission = "votations.list_votations"
    model = Votation
    template_name = "votations/list.html"

    def get(self, request):
        previous_btn = {"active": "", "pressed": "", "href": "?status=1", "text": "Show"}
        votations = Votation.objects.all()
        votations = votations.filter(end_date__gte=datetime.now())

        if self.request.GET.get("status", None) == "0":
            votations = votations.filter(end_date__gte=datetime.now())
            previous_btn = {"active": "active", "pressed": "", "href": "?status=1", "text": "Show"}
        elif self.request.GET.get("status", None) == "1":
            votations = Votation.objects.all()
            previous_btn = {"active": "", "pressed": "true", "href": "?status=0", "text": "Hide"}

        return render(
            request=request,
            template_name=self.template_name,
            context={"votation_list": votations, "previous_btn": previous_btn},
        )


class DetailView(CoreDetailView):
    personal = False
    permission = "votations.manage_votations"
    model = Votation
    template_name = "votations/detail.html"


class DeleteView(CoreDeleteView):
    personal = False
    permission = "votations.manage_votations"
    model = Votation
    template_name = "votations/delete.html"


class CreateView(CoreCreateView):
    personal = False
    permission = "votations.manage_votations"
    model = Votation
    form_name = VotationForm
    template_name = "votations/create.html"
    choices_formset_factory = inlineformset_factory(
        parent_model=Votation,
        model=VotationChoice,
        form=VotationChoiceModelForm,
        formset=VotationChoicesFormSet,
        can_order=False,
        can_delete=False,
    )

    def get(self, request, *args, **kwargs):
        """Overriding get method to handle inline formset."""
        self.object = None
        form = VotationForm()
        formset = self.choices_formset_factory()
        return render(request=request, template_name=self.template_name, context={"form": form, "choices": formset})

    def post(self, request, *args, **kwargs):
        """Overriding post method to handle inline formsets."""
        self.object = None
        form = VotationForm(request.POST)
        formset = self.choices_formset_factory(self.request.POST)

        if form.is_valid():
            self.object = form.save(commit=False)
            formset = self.choices_formset_factory(self.request.POST, instance=self.object)
            if formset.is_valid():
                self.object.save()
                formset.save()
                return HttpResponseRedirect(self.next)

        return render(request=request, template_name=self.template_name, context={"form": form, "choices": formset})


class EditView(CoreEditView):
    personal = False
    permission = "votations.manage_votations"
    model = Votation
    form_name = VotationForm
    template_name = "votations/edit.html"
    choices_formset_factory = inlineformset_factory(
        parent_model=Votation,
        model=VotationChoice,
        form=VotationChoiceModelForm,
        formset=VotationChoicesFormSet,
        extra=1,
        can_order=False,
        can_delete=True,
    )

    def get(self, request, *args, **kwargs):
        """Overriding get method to handle inline formset."""
        if self.votation.get_votation_status() != "pending":
            messages.error(request, "You cannot edit a votation after it has started.")
            return HttpResponseRedirect(self.next)
        form = VotationForm(instance=self.votation)
        formset = self.choices_formset_factory(instance=self.votation)
        return render(request=request, template_name=self.template_name, context={"form": form, "choices": formset})

    def post(self, request, *args, **kwargs):
        """Overriding post method to handle inline formsets."""
        form = VotationForm(request.POST, instance=self.votation)
        formset = self.choices_formset_factory(self.request.POST, instance=self.votation)

        if form.is_valid() and formset.is_valid():
            form.save()
            formset.save()
            messages.success(request, _("The votation has been successfully edited."))
            return HttpResponseRedirect(self.next)
        else:
            return render(request=request, template_name=self.template_name, context={"form": form, "choices": formset})


class PublicListView(CoreListView):
    personal = False
    permission = False
    model = Votation
    paginate_by = 5
    template_name = "votations/publiclist.html"

    def get_context(self):
        context = super().get_context()
        context["date"] = datetime.now()
        context["num_of_elements"] = context["votation_list"].count()
        return context

    def get(self, request, *args, **kwargs):
        votations = Votation.objects.all().order_by("-end_date")
        paginator = Paginator(votations, 5)

        page_number = request.GET.get('page')
        page_obj = paginator.get_page(page_number)
        return render(request, self.template_name, {'page_obj': page_obj})

class VoteView(PermissionMixin, GroupPermissionMixin, FormView):
    personal = False
    permission = True
    form_class = VotationDecisionForm
    votation = None
    model = Votation
    decision = None
    success_url = "/votations/list/"
    template_name = "votations/normalvote.html"

    def load_votation(self, pk):
        self.votations = Votation.objects.get(pk=pk)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["object"] = self.decision
        context["votation"] = self.votations
        return context

    def dispatch(self, request, *args, **kwargs):
        self.load_votation(kwargs["pk"])
        if self.votations.get_votation_status() != "open":
            messages.error(request, "The votation is not open for voting.")
            return HttpResponseRedirect(self.get_success_url())
        elif not self.request.user.is_authenticated:
            return HttpResponseRedirect("/accounts/login/")

        user = self.request.user
        if user.votations.filter(pk=self.votations.pk).exists():
            messages.error(request, "You have already voted!")
            return HttpResponseRedirect(self.get_success_url())

        return super().dispatch(request, *args, **kwargs)

    def form_valid(self, form):
        with transaction.atomic():
            # Save our vote
            instance = VotationDecision()
            instance.votation = self.votations
            instance.choice = VotationChoice.objects.get(pk=form.cleaned_data["choice_pk"])
            instance.save()
            # Save that we voted
            self.request.user.votations.add(self.votations)
            self.request.user.save()

        return super().form_valid(form)

    def get_template_names(self):
        if self.votations.votation_type == "ranked":
            return ["votations/rankvote.html"]
        else:
            return ["votations/normalvote.html"]


class VoteRankedView(PermissionMixin, GroupPermissionMixin, FormView):
    personal = False
    permission = True
    form_class = VotationRankedDecisionForm
    success_url = "/votations/list/"
    votation = None
    model = Votation
    template_name = "votations/rankvote.html"

    def load_votation(self, pk):
        self.votation = Votation.objects.get(pk=pk)

    def dispatch(self, request, *args, **kwargs):
        self.load_votation(kwargs["pk"])
        if self.votation.get_votation_status() != "open":
            messages.error(request, "The votation is not open for voting.")
            return HttpResponseRedirect(self.get_success_url())
        elif not self.request.user.is_authenticated:
            return HttpResponseRedirect("/accounts/login/")

        user = self.request.user
        if user.votations.filter(pk=self.votation.pk).exists():
            messages.error(request, "You have already voted!")
            return HttpResponseRedirect(self.get_success_url())

        return super().dispatch(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        with transaction.atomic():
            # Save that we voted
            self.request.user.votations.add(self.votation)
            self.request.user.save()

            # Create a vote
            vote = VotationVote()
            vote.save()

            # Save our candidate decisions
            for r in range(VotationChoice.objects.filter(votation=self.votation).count()):
                instance = VotationDecision()
                instance.votation = self.votation
                instance.choice = VotationChoice.objects.get(pk=request.POST.get("result-" + str(r)))
                instance.rank = r
                instance.vote = vote
                instance.save()

        return super().post(request, *args, **kwargs)


class ResultView(CoreDetailView):
    personal = False
    permission = False
    model = Votation

libreorganize/apps/votations/templates/votations/delete.html
{% extends "core/delete.html" %}
{% load i18n %}

{% block title %}{% trans "Delete Votation" %}{% endblock title %}

{% block form_title %}
<h1>{% trans "Delete Votation" %}</h1>
{% endblock form_title %}

{% block form_message %}
{% trans "Are you sure you want to delete the votation?" %}
<br>
{% trans "This action is irreversible." %}
{% endblock form_message %}

libreorganize/apps/votations/templates/votations/detail.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans 'View Votation' %}{% endblock %}

{% block content %}
<div class="container">
    <div class="row no-gutters card-row">
        <div class="col-12 mx-auto my-auto">
            <div class="card">
                <div class="card-header text-center">
                    <h1>{% trans 'View Votation' %}</h1>
                </div>
                <div class="card-body">
                    <div class="container">
                        <div class="row">
                            <div class="col-md-4 col-lg-3 px-0 pr-md-2 pb-3">
                                {% if votation.get_votation_status == "open" %}
                                <a class="btn btn-success btn-detail"
                                    href="{% url 'votations:vote' pk=votation.pk %}?next={{ request.get_full_path }}">
                                    <i class="fas fa-vote-yea"></i>
                                    {% trans "Vote in Votation"%}
                                </a>
                                {% endif %}
                                {% if votation.get_votation_status == "closed" %}
                                <a class="btn btn-info btn-detail"
                                    href="{% url 'votations:results' pk=votation.pk %}?next={{ request.get_full_path }}">
                                    <i class="fas fa-poll fa-fw mr-1"></i>
                                    {% trans "Votation Results"%}
                                </a>
                                {% endif %}
                                {% if perms.votations.manage_votations and votation.get_votation_status == "pending" %}
                                <a class="btn btn-warning btn-detail"
                                    href="{% url 'votations:edit' pk=votation.pk %}?next={{ request.get_full_path }}">
                                    <i class="fas fa-pen fa-fw mr-1"></i>
                                    {% trans "Edit Votation" %}
                                </a>
                                {% endif %}
                                {% if perms.votations.manage_votations %}
                                <a class=" btn btn-danger btn-detail"
                                    href="{% url 'votations:delete' pk=votation.pk %}?next=/votations/">
                                    <i class="fas fa-trash fa-fw mr-1"></i>
                                    {% trans "Delete Votation" %}
                                </a>
                                {% endif %}
                            </div>
                            <div class="col-md-8 col-lg-9 px-0 pl-md-2">
                                <div class="table-mobile">
                                    <table class="table table-striped table-detail" id="mobileTable">
                                        <tbody>
                                            <tr>
                                                <th scope="row">Votation ID</th>
                                                <td>{{ votation.pk }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Topic" %}</th>
                                                <td>{{ votation.topic }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Description" %}</th>
                                                <td>{{ votation.description }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Start Date" %}</th>
                                                <td>{{ votation.start_date }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "End Date" %}</th>
                                                <td>{{ votation.end_date }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Type" %}</th>
                                                <td>{{ votation.get_votation_type_display }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "List of choices" %}</th>
                                                <td>
                                                    {% for choice in votation.votationchoice_set.all %}
                                                    {{ choice.name }}<br>
                                                    {% endfor %}
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

libreorganize/apps/votations/templates/votations/list.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans 'Votations' %}{% endblock %}

{% block content %}
<div class="container">
    <div class="row card-row">
        <div class="col-12 mx-auto my-auto">
            <div class="card">
                <div class="card-header text-center">
                    <h1>{% trans "Votations" %}</h1>
                </div>
                <div class="card-body">
                    <table id="jsTable" class="table table-striped nowrap" style="width: 100%;">
                        <thead>
                            <tr>
                                <th scope="col">Votation ID</th>
                                <th scope="col">{% trans "Topic" %}</th>
                                <th scope="col">{% trans "Start Date" %}</th>
                                <th scope="col">{% trans "End Date" %}</th>
                                <th scope="col">{% trans "Type" %}</th>
                                <th scope="col">{% trans "Status" %}</th>
                                <th scope="col">
                                    {% if perms.votations.manage_votations %}
                                    <a class="btn btn-sm btn-success" data-toggle="tooltip" title="{% trans 'Create Votation' %}"
                                        href="{% url 'votations:create' %}?next={{ request.get_full_path }}">
                                        <i class="fas fa-plus fa-fw"></i>
                                    </a>
                                    <a class="btn btn-sm btn-info" data-toggle="tooltip" title="{% trans 'Public List' %}"
                                        href="{% url 'votations:public_list' %}">
                                        <i class="fas fa-list fa-fw"></i>
                                    </a>
                                    {% endif %}
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for votation in votation_list %}
                            <tr>
                                <td>{{ votation.pk }}</td>
                                <td>{{ votation.topic }}</td>
                                <td>{{ votation.start_date }}</td>
                                <td>{{ votation.end_date }}</td>
                                <td>{{ votation.get_votation_type_display }}</td>
                                <td>{{ votation.get_votation_status_display }}</td>
                                <td>
                                    {% if perms.votations.manage_votations %}
                                    <a class="btn btn-sm btn-info" data-toggle="tooltip" title="{% trans 'View Votation' %}"
                                        href="{% url 'votations:detail' pk=votation.pk %}">
                                        <i class="fas fa-eye fa-fw"></i>
                                    </a>
                                    {% endif %}
                                    {% if perms.votations.manage_votations and votations.get_votation_status == "pending" %}
                                    <a class="btn btn-sm btn-warning" data-toggle="tooltip" title="{% trans 'Edit Votation' %}"
                                        href="{% url 'Votations:edit' pk=votation.pk %}?next={{ request.get_full_path }}">
                                        <i class="fas fa-pen fa-fw"></i>
                                    </a>
                                    {% endif %}
                                    {% if perms.votations.manage_votations %}
                                    <a class="btn btn-sm btn-danger" data-toggle="tooltip" title="{% trans 'Delete Votation' %}"
                                        href="{% url 'votations:delete' pk=votation.pk %}?next={{ request.get_full_path }}">
                                        <i class="fas fa-trash fa-fw"></i>
                                    </a>
                                    {% endif %}
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                    <div class="container-fluid no-gutters">
                        <div class="row">
                            <a class="btn btn-outline-secondary {{ previous_btn.active }}" data-toggle="button"
                                aria-pressed="{{ previous_btn.pressed }}" href="{% url 'votations:list' %}{{ previous_btn.href }}">
                                {{ previous_btn.text }} <span class="badge badge-success font-weight-normal"><i
                                        class='fas fa-history fa-fw'></i> CLOSED VOTATIONS</span>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

libreorganize/apps/votations/templates/votations/publiclist.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans 'Public Votations' %}{% endblock %}

{% block content %}
<div class="row no-gutters card-row">
    <div class="col-11 mx-auto my-auto">
        <div class="card">
            <div class="card-header">
                <h1 class="text-center">{% trans "Public Votations" %}</h1>
            </div>
            <div class="card-body">
                {% if num_of_elements == 0 %}
                <h5>There are no active votations</h5>
                {% endif %}

                {% for votation in page_obj %}
                <div class="card">
                    <h3 class="card-header">{{ votation.topic }}</h3>
                    <div class="card-body">
                        {% if votation.get_votation_status == "closed" %}
                        <span class="badge badge-danger"><i class="fas fa-times"></i> Closed</span>
                        <hr>
                        {% elif votation.get_votation_status == "open" %}
                        <span class="badge badge-success"><i class="fas fa-check"></i> Open</span>
                        <hr>
                        {% else %}
                        <span class="badge badge-warning"><i class="fas fa-exclamation-triangle"></i> Pending</span>
                        <hr>
                        {% endif %}

                        <p><strong>Description: </strong>{{ votation.description }}</p>
                        <h6 class="card-title"><strong>Opens</strong>- {{ votation.start_date }}</h6>
                        <h6 class="card-title"><strong>Expires</strong>- {{ votation.end_date }}</h6>

                        {% if votation.get_votation_status != "pending" %}
                        {% if votation.get_votation_status == "closed" %}
                        <a href="{% url 'votations:vote' pk=votation.pk %}?next={{ request.get_full_path }}" class="btn btn-primary disabled"><i
                                class="fas fa-vote-yea"></i> Vote</a>
                        <a href="{% url 'votations:results' pk=votation.pk %}" class="btn btn-primary"><i class="fas fa-poll"></i> Results</a>
                        {% else %}
                        {% if votation not in request.user.votations.all %}
                        <a href="{% url 'votations:vote' pk=votation.pk %}?next={{ request.get_full_path }}" class="btn btn-primary"><i
                                class="fas fa-vote-yea"></i> Vote</a>
                        {% else %}
                        <a href="{% url 'votations:vote' pk=votation.pk %}?next={{ request.get_full_path }}" class="btn btn-primary disabled"><i
                                class="fas fa-vote-yea"></i> Vote</a>
                        {% endif %}
                        {% endif %}
                        {% endif %}
                    </div>
                </div>
                <br><br>
                {% endfor %}
                {% if page_obj.has_previous %}
                <a class="btn btn btn-outline-primary mb-4" href="?page={{ page_obj.previous_page_number }}"><i class="fas fa-arrow-left"></i></a>
                {% endif%}

                {% for num in page_obj.paginator.page_range %}
                {% if page_obj.number == num %}
                <a class="btn btn-secondary mb-4" href="?page={{ num }}">{{ num }}</a>
                {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}<a class="btn btn btn-outline-secondary mb-4" href="?page={{ num }}">{{ num }}</a>
                {% endif %}
                {% endfor%}
                
                {% if page_obj.has_next %}
                <a class="btn btn btn-outline-primary mb-4" href="?page={{ page_obj.next_page_number }}"><i class="fas fa-arrow-right"></i></a>
                {% endif%}
            </div>
        </div>
    </div>
</div>
{% endblock %}

libreorganize/apps/votations/templates/votations/results.html
{% extends "base.html" %}
{% load i18n %}
{% load crispy_forms_tags %}

{% block title %}{% trans 'Results' %}{% endblock %}

{% block content %}
<div class="container">
    <div class="row no-gutters card-row">
        <div class="col-12 col-sm-9 col-lg-6 mx-auto my-auto">
            <div class="card">
                <div class="card-header">
                    <h1 class="text-center">Results - {{ votation.topic }}</h1>
                </div>
                <div class="card-body">
                    {% if votation.get_votation_status != "pending" %}
                        {% if votation.get_votation_status == "closed" %}
                        <span class="badge badge-danger"><i class="fas fa-times"></i> Closed</span><hr>
                        {% else %}
                        <span class="badge badge-success"><i class="fas fa-check"></i> Open</span><hr>
                        {% endif %}
                    {% endif %}
                    <h5><strong>Description - </strong>{{ votation.description }}</h5>
                    <h5><strong>Winner - </strong>{{ votation.winner.name }}</h5>
                    {% if votation.votation_type != "ranked" %}
                    <br>
                    <table class="table table-striped table-bordered">
                    <thead>
                        <tr>
                            <th scope="col"><h5>Choice</h5></th>
                            <th scope="col"><h5>Total Votes</h5></th>
                        </tr>
                    </thead>
                    <tbody>
                    {% for result in results %}
                        <tr>
                            <th scope="row">{{ result.0 }}</th>
                            <td>{{ result.1 }}</td>
                        </tr>
                    {% endfor %}
                    </tbody>
                    </table>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}